
// Data correction
for (var i = 0; i < geojson.length; i++) {
	geojson[i]["type"] = "Feature";
	geojson[i]["properties"] = geojson[i]["fields"];
	//if (geojson[i]["properties"]["url"] !== undefined && geojson[i]["properties"]["url"].indexOf("http://") < 0) {
	//	geojson[i]["properties"]["url"] = 'http://' + geojson[i]["properties"]["url"];
	//}
}

var OpenStreetMap = L.tileLayer('https://{s}.tile.openstreetmap.fr/osmfr/{z}/{x}/{y}.png', {
	maxZoom: 20,
	attribution: '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>'
});


var map = new L.Map("map", {
	center: new L.LatLng(49.03, 2.29),
	zoom: 10.3,
	layers: [OpenStreetMap],
});

var markerClusters = L.markerClusterGroup();

var cats = [];
for (var i = 0; i < geojson.length; i++) {
	var cat = getCat(cats, geojson[i].properties.categorie1);
	if (cat === undefined) {
		cat = {
			"interestPoints": createInterestPoints(),
			"id": "cat" + i,
			"label": geojson[i].properties.categorie1
		}
		cats.push(cat);
	}
	cat["interestPoints"].addData(geojson[i]);
}

/*	
	var command = L.control({position: 'topright'});
	command.onAdd = function (map) {
		var div = L.DomUtil.create('div', 'command');
		div.innerHTML += '<div style="text-align:center;"><span style="font-size:18px;">Serveurs SambaÉdu 4 déployés</span><br /><span style="color:grey;font-size:14px;">(Team SambaÉdu)</span></div>';
		for (var i = 0; i < cats.length; i++) {
			div.innerHTML += '<form><input id="' + cats[i]["id"] + '" type="checkbox" />' + cats[i]["label"] + '</form>' ;
		}
		return div;
	};
	command.addTo(map);
	for (var i = 0; i < cats.length; i++) {
		document.getElementById(cats[i]["id"]).addEventListener("click", handleCommand, false);
	}
*/

function handleCommand() {
	var selectedCat;
	for (var i = 0; i < cats.length; i++) {
		if (cats[i]["id"] === this.id) {
			selectedCat = cats[i];
			break;
		}
	}
	if (this.checked) {
		selectedCat["interestPoints"].addTo(map);
	} else {
		map.removeLayer(selectedCat["interestPoints"]);
	}
}

function getCat(cats, cat) {
	for (var i = 0; i < cats.length; i++) {
		if (cats[i]["label"] === cat) {
			return cats[i];
		}
	}
	return;
}

function createInterestPoints() {
	return new L.geoJson([], {
		pointToLayer: function(feature, latlng) {
			var smallIcon = L.icon({
				iconUrl: getIcon(feature.properties.etat, feature.properties.categorie1),
				//shadowUrl: 'icon-shadow.png',
				//					iconSize:     [33, 44], // taille de l'icone
				//shadowSize:   [50, 64], // taille de l'ombre
				iconAnchor: [16, 44], // point de l'icone qui correspondra à la position du marker
				//shadowAnchor: [32, 64],  // idem pour l'ombre
				popupAnchor: [-3, -46] // point depuis lequel la popup doit s'ouvrir relativement à l'iconAnchor
			});
			return L.marker(latlng, { icon: smallIcon });
		},
		onEachFeature: function(feature, layer) {
			var html = '';
			if (feature.properties.titre) {
				html += '<b>' + feature.properties.titre + '</b> (' + feature.properties.uai + ')</br>';
			}
			if (feature.properties.alive > 0) {
				if (feature.properties.titre2) {
					html += 'Description :' + feature.properties.description + '</br>';
				}
				if (feature.properties.url) {
					html += '<a href="' + central_uri + '/' + feature.properties.uai.toLowerCase() + '/admin/" target="_blank">Interface SE4FS</a>.</br>';
					html += '<a href="https://' + feature.properties.pve_ip + ':8006/" target="_blank">Interface PVE</a>.</br>';
				}
				if (feature.properties.ipfs) {
					html += 'SE4FS : ' + feature.properties.se4fs_ip + '</br>';
				}
				if (feature.properties.ipad) {
					html += 'SE4AD : ' + feature.properties.se4ad_ip + '</br>';
				}
				var milliseconds = new Date().getTime();
				var alive = Math.round(milliseconds / 1000) - feature.properties.alive;
				// 
				if (feature.properties.etat === "actif") {
					html += 'CPU load  : ' + feature.properties.cpu + '  / Ram : ' + feature.properties.ram + '</br>';
					html += 'Dernière requête : ' + alive + ' secondes.</br>';
					html += '<a href="?page=sds&host=' + feature.properties.uai.toLowerCase() + '">Stats, recherches, gestion de ce site.</a>';
				} else {
					html += '<b>Serveur injoignable depuis  ' + alive + ' secondes.</b></br>';
				}
			} else if (feature.properties.etat === "inactif") {
				html += 'Établissement à activer.</br>';
				html += '<a href="?page=auns&uai=' + feature.properties.uai + '">Provisionner cet établissement.</a>';
			} else if (feature.properties.etat === "provisionning") {
				html += 'Établissement en attente d\'installation.</br>';
			}
			layer.bindPopup(html);
			markerClusters.addLayer(layer);
		}
	});
}

function getIcon(etat, categorie) {
	if (categorie === "Central") {
		return "icons/N.png";
	}
	if (etat === "inactif") {
		return "icons/I.png";
	} else if (etat === "actif") {
		return "icons/V.png";
	} else if (etat === "injoignable") {
		return "icons/R.png";
	} else if (etat === "provisionning") {
		return "icons/M.png";
	} else {
		return "icons/N.png";
	}
}
function openAtOpen() {
	var selectedCat;
	for (var i = 0; i < cats.length; i++) {
		selectedCat = cats[i];
		// selectedCat["interestPoints"]; // avec les clusters
		selectedCat["interestPoints"].addTo(map);//  Affiche les points directement
		// map.addLayer(markerClusters);
	}
}
