/*
 * Génnère un mot de passe
 * et l'affiche dans la div 
 * GeneratePassword 
 */
function GeneratePassword() {
	var randomstring = genererMotDePasse(12);
	var div = document.getElementById('GeneratePassword');
	div.innerHTML = escapeHTML(randomstring);
}
function genererMotDePasse(longueur) {
	const majuscules = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	const minuscules = "abcdefghijklmnopqrstuvwxyz";
	const chiffres = "0123456789";
	const caracteresSpeciaux = "!@#$%^&*()_+[]{}|;:,.<>?";
	const tousLesCaracteres = majuscules + minuscules + chiffres + caracteresSpeciaux;
	let motDePasse = "";
	// S'assurer d'avoir au moins un caractère de chaque type
	motDePasse += majuscules[Math.floor(Math.random() * majuscules.length)];
	motDePasse += minuscules[Math.floor(Math.random() * minuscules.length)];
	motDePasse += chiffres[Math.floor(Math.random() * chiffres.length)];
	motDePasse += caracteresSpeciaux[Math.floor(Math.random() * caracteresSpeciaux.length)];
	// Compléter avec des caractères aléatoires jusqu'à atteindre la longueur souhaitée
	for (let i = motDePasse.length; i < longueur; i++) {
		motDePasse += tousLesCaracteres[Math.floor(Math.random() * tousLesCaracteres.length)];
	}
	// Mélanger le mot de passe
	motDePasse = motDePasse.split('').sort(() => Math.random() - 0.5).join('');
	return motDePasse;
}
function escapeHTML(str) {
	return str.replace(/&/g, "&amp;")
		.replace(/</g, "&lt;")
		.replace(/>/g, "&gt;")
		.replace(/"/g, "&quot;")
		.replace(/'/g, "&#039;");
}

/*
 * Recherche
 */
function Search() {
	var elt = document.getElementById('SearchUAI');
	document.location.href = 'index.php?page=sds&host=' + elt.value;
}

function formatDate(date) {
	const hours = String(date.getHours()).padStart(2, "0");
	const minutes = String(date.getMinutes()).padStart(2, "0");
	const day = String(date.getDate()).padStart(2, "0");
	const month = String(date.getMonth() + 1).padStart(2, "0"); // Les mois commencent à 0
	return `${day}/${month} - ${hours}:${minutes}`;
}
/*
 * Graphe des stats
 * 
 */
function GraphStats(quoi, i, fluxResponse, ymax) {
	const lineLayer = {
		type: "line",
		x: "_time",
		y: "_value",
		lineWidth: 2,
		fill: [],
		position: "overlaid",
		interpolation: "monotoneX",
		hoverDimension: "auto",
		shadeBelow: true,
		shadeBelowOpacity: 0.1,
	};
	MaConf = {
		fluxResponse,
		layers: [lineLayer],
		fluxResponse,
		xScale: "linear",
		yScale: "linear",
		legendColorizeRows: true,
		legendFont: "0.9em sans-serif",
		tickFont: "0.8em sans-serif",
		yDomain: [0, ymax],
		onSetYDomain: [0, ymax],
		onResetYDomain: [0, ymax],
		valueFormatters: {
			_time: (t) => formatDate(new Date(t)),
			_value: (num) => num.toFixed(0),
		},
	};
	class PlotRenderer extends React.Component {
		render() {
			const style = {
				width: "calc(99%)",
				height: "calc(30vh)",
				margin: "0em",
			};
			const config = MaConf;
			const SimplePlot = React.createElement(Giraffe.Plot, { config }, null);
			return React.createElement("div", { style }, SimplePlot);
		}
	}
	ReactDOM.render(
		React.createElement(PlotRenderer),
		document.getElementById("ChargeServeurs" + i)
	);
}


function openInNewWindow(event, link) {
	event.preventDefault();
	window.open(link.href, '_blank', 'noopener,noreferrer,width=1920,height=1080');
}
