<?php

/*
 * Accès à distance
 *
 */
function aad($config, &$html)
{
    $etab = $_POST['etab'] ?? $_GET['etab'] ?? $_POST['host'] ?? $_GET['host'] ?? $_SESSION['etab'] ?? "";
    $titre = "Ouvrir une session sur un ordinateur d'un établissement";
    $html2 = "";
    if (! empty($etab)) {
        $titre = "Ouvrir une session sur un ordinateur de l'établissement " . substr(etab_to_name(get_config($config, true, $etab), $etab), 1, - 1);
        /**
         * Si on a l'étab on propose la gestion à distance
         * ou les parcs à gérer
         */
        $titre1 = "Contrôler les parcs -  " . substr(etab_to_name(get_config($config, true, $etab), $etab), 1, - 1);
        $titre2 = "Gestion des parcs -  " . substr(etab_to_name(get_config($config, true, $etab), $etab), 1, - 1);
        /*
         * Création du token Guacamole
         */
        $url = create_remote_token($config, search_machine($config, $config['remote_admin_machine'] . etab_suffix($etab)), "master", $config['login']);
        $content1 = "<a href=\"" . $url . "\" onclick=\"openInNewWindow(event, this)\">";
        $content1 .= '<center>
						<button type = "submit" class="btn btn-primary btn-icon-split ">
							<span class="icon text-white-50">
							<i class="fas fa-computer"></i>
							</span>
							<span class="text">Contrôle à distance des parcs</span>
						</button>
					</center>';
        $content1 .= "</a>";
        $content2 = "<center>";
        $content2 .= " " . form_list_parc($config, $etab);
        $content2 .= "</center>";
        $html2 = '<div class="row">';
        $html2 .= html_box_card(6, 1, 1, $titre1, $content1);
        $html2 .= html_box_card(6, 1, 1, $titre2, $content2);
        $html2 .= '</div>';
    }
    /*
     * On commence par choisir l'étab
     */
    $content = search_etab_form($etab, "aad");
    $html .= '<div class="row">';
    $html .= html_box_card(12, 7, 4, $titre, $content);
    $html .= '</div>';
    $html .= $html2;
}

/*
 * Profuils et liste des utilisateurs/groupes
 */
function dds($config, &$html)
{
    // on repasse en contexte global
    $_SESSION['etab'] = 0;
    $config = get_config($config, true, true);
    $profils = search_ad($config, "*", "right");
    $available_rights = right_info(SE_ADMIN);
    $profil = $_POST['profil'] ?? "";
    $droit = $_POST['droits'] ?? "";
    if ($profil == "") {
        $profil = $profils['0']['cn']; // Profil listé par défaut RefNum
        $members = $profils['0']['member'];
    }
    /*
     * début de ligne
     */
    $html .= "<div class=\"row\">";

    /*
     *
     * Liste des Profiles
     *
     */
    $titre = "Liste des profils";
    $content = "<form action=\"index.php?page=dds\" method=\"post\" class=\"rounded-bar\"><select name=\"profil\" class=\"form-control bg-primary text-white border-0 small\" onchange=\"submit();\">";
    foreach ($profils as $right) {
        $content .= "<option value='" . $right['cn'] . "' ";
        if ($profil == $right['cn']) {
            $content .= "selected";
            $members = $right['member'] ?? [];
            $info = $right['info'];
            $gdn = $right['dn'];
        }
        $content .= ">" . $right['cn'];
        if ((array_key_exists('description', $right)) && ($right['description'] != "")) {
            $content .= " (" . $right['description'] . ")";
        }
    }
    $content .= "</select></form>";
    $html .= html_box_card(12, 1, 1, $titre, $content);
    /*
     *
     * Liste des droits du profil
     *
     */
    $titre = "Liste des droits du profil $profil";
    $content = "<ul>";
    if ($info == "") {
        $map = [
            "se3_is_admin" => SE_ADMIN,
            "Annu_is_admin" => SE_COMPUTER_ADMIN,
            "computer_is_admin" => SE_COMPUTER_ADMIN,
            "password_can_reinit" => SE_USER_PASSWORD_INIT,
            "annu_can_read" => SE_USER_PASSWORD_INIT | SE_USER_READ,
            "sovajon_is_admin" => SE_ELEVE_ADMIN
        ];
        $info = $map[$profil] ?? SE_NO_RIGHT;
    }
    $rights = right_info($info);
    foreach ($available_rights as $k => $msg) {
        if (isset($rights[$k])) {
            $content .= "<li class=\"\">" . $msg . "</li>";
        } else {
            $content .= "<li class=\"small\"><strike>" . $msg . "</strike></li>";
        }
    }
    $content .= "</ul>";
    $html .= html_box_card(4, 1, 1, $titre, $content);

    /*
     * Liste des utilisateurs ayant ce profil
     */
    $titre = "";
    $content = "<ul>";
    $contentGrp = "<ul>";
    $nbUser = 0;
    $nbGrp = 0;
    foreach ($members as $member) {
        $uai_member = ldap_dn2uai($member);

        /* on renvoit le lien vers la fiche user ou la fiche groupe selon le cas */
        if (preg_match("/OU=Groups/i", $member)) {
            $contentGrp .= "<li class=\"small\">" . "<a href=\"?page=r&dn=" . $member . "\" >" . ldap_dn2cn($member) . "</a></li>";
            $nbGrp += 1;
        } else {
            $email = search_user($config, $member)['email'];
            if (! empty($email)) {
                $email = "<a href=\"mailto:$email\">@</a> ,";
            }

            $content .= "<li class=\"small\">" . "<a href=\"?page=r&cn=" . $member . "\" >" . ldap_dn2cn($member) . "</a> ($email" . $uai_member . ")" . "</li>";
            $nbUser += 1;
        }
    }
    $content .= "</ul>";
    $content .= "<a href=\"grouplist.php?dn=" . urlencode($gdn) . "\" target='_new'>Afficher un listing des membres</a>\n";
    $contentGrp .= "</ul>";
    $titre = "<div>$nbUser utilisateur(s) ayant le profil <b>$profil</b></div> <a href=\"grouplist.php?dn=" . urlencode($gdn) . "\" target='_new'><i  class=\"fa cta fa-list\"></i></a>";
    $html .= html_box_card(4, 1, 1, $titre, $content);
    $titre = "<div>$nbGrp groupe(s) ayant le profil <b>$profil</b></div>";
    $html .= html_box_card(4, 1, 1, $titre, $contentGrp);

    /*
     * Fin de la row
     */
    $html .= "</div>";
}

/*
 * Créer un compte tech
 */
function cuc($config, &$html)
{
    /*
     * En cas d'envoi du formulaire, on traite la création
     */
    $Nom = $_POST['nom'] ?? "";
    $Prenom = $_POST['prenom'] ?? "";
    $Password = $_POST['userpw'] ?? "";
    if (($Nom != "") && ($Prenom != "") && ($Password != "")) {

        $_POST['naissance'] = "";
        $_POST['sexe'] = "";
        $_POST['categorie'] = "Administratifs";
        $_POST['login'] = "";
        $_POST['id'] = "";
        $_POST['classes'] = [];
        $_POST['add_user'] = true;
        $_POST['fonction'] = "Tech";
        $_POST['new_etab'] = 0;

        $titre = "Création de l'utilisateur  $Prenom  $Nom";
        $content = "";
        add_user_html($config, $content);
        $html .= html_box_card(12, 1, 1, $titre, $content);
    }
    /*
     * Liste des techniciens
     *
     */
    $html .= "<div class=\"row\">";
    $content = "";
    $result = list_members_group($config, "Tech");
    foreach ($result as $key => $value) {
        $cn = $value["cn"];
        $prenom = $value["prenom"];
        $nom = $value["nom"];
        $content .= "<li class=\"small\">" . "<a href=\"?page=r&cn=" . $cn . "\" >" . ucfirst(strtolower($prenom)) . " " . ucfirst(strtolower($nom)) . "</a></li>";
    }

    $titre = "Liste des  " . count($result) . " techniciens";
    $html .= html_box_card(3, 1, 1, $titre, $content);
    /*
     * Form de création d'un nouveau tech
     */
    $titre = "Créer un nouveau compte Technicien.";
    $content = "";
    $content = '<form class="d-none d-sm-inline-block form-inline mr-auto ml-md-2 my-2 my-md-2 mw-100 navbar-search" method="post" action="index.php?page=cuc">
			<div class="input-group">
			<ul class="list-group">
			<li  class="list-group-item">
				<input type="text" name ="nom"  class="form-control bg-light border-0 small" placeholder="Nom"   aria-label="Nom" aria-describedby="basic-addon2">
			</li>
			<li class="list-group-item">
				<input type="text" class="form-control bg-light border-0 small" placeholder="Prénom" aria-label="Prénom" aria-describedby="basic-addon2" name="prenom">
			</li>
			<li class="list-group-item">
				<input type="password" class="form-control bg-light border-0 small" placeholder="Mot de passe" aria-label="Mot de passe" aria-describedby="basic-addon2" name="userpw">
			</li>
			</ul>
				<div class="input-group-append">
					<button class="btn btn-primary" type="submit">
						<i class="fas fa-user-lock fa-sm"></i>
					</button>
				</div>
			</div>
		</form>';
    $html .= html_box_card(6, 1, 1, $titre, $content);
    $titre = "Suggestion de mot de passe";
    $content = '<center><button class="btn btn-primary" type="submit" onclick="GeneratePassword();" ><i class="fas fa-key fa-2x"></i></button>';
    $content .= '<div id="GeneratePassword" class=" mr-auto ml-md-2 my-2 my-md-2 mw-100"></div></center>';
    $html .= html_box_card(3, 1, 1, $titre, $content);
    $html .= "</div>";
}

function comptesInvites($config, &$html)
{
    require_once ("user.interface.inc.php");
    $etab = $_POST['etab'] ?? $_GET['etab'] ?? $_POST['host'] ?? $_GET['host'] ?? $_SESSION['etab'] ?? "";
    /*
     * On commence par choisir l'étab
     */
    $value = "";
    $titre = "Créer des comptes invités dans un établissement";
    $html2 = "";
    if (! empty($etab)) {
        $titre = "Création de comptes invités dans l'établissement : " . etab_to_name(get_config($config, true, $etab), $etab) . " ($etab)";
        $value = $etab;
        /**
         * Si l'établissement est passé
         * On envoie le formulaire de création ou son analyse
         * après le formulaire de choix de l'établissement
         */
        $login = $config['login'];
        $user = search_user($config, $login);
        $content = create_temp_users(get_config($config, true, $etab), $user);
        $html2 = '<div class="row">';
        $html2 .= html_box_card(12, 7, 4, $titre, $content);
        $html2 .= '</div>';
    }
    $content = search_etab_form($etab, "ci");
    $html = '<div class="row">';
    $html .= html_box_card(12, 7, 4, $titre, $content);
    $html .= '</div>';
    $html .= $html2;
}

function form_search_user($config)
{
    $etab = $_POST['etab'] ?? $_GET['etab'] ?? $_POST['host'] ?? $_GET['host'] ?? $_SESSION['etab'] ?? "";
    if (! empty($etab)) {
        $value = "value = \"$etab\"";
    } else {
        $value = "";
    }
    /**
     * Si le host est passé en GET
     * inutile d'fficher l'input du host
     */
    $hidden = "type=\"text\"";
    if (! empty($_GET['host'])) {
        $hidden = "type =\"hidden\"";
    }

    $content = '<form class="d-none d-sm-inline-block form-inline mr-auto ml-md-2 my-2 my-md-2 mw-100 navbar-search" method="post" action="index.php?page=r">
			<div class="input-group">
			<ul class="list-group">
			<li  class="list-group-item">
				<input name ="etab" class="form-control bg-light border-0
                                small" placeholder="Limiter à l\'établissement..." ' . $value . ' aria-label="Search" aria-describedby="basic-addon2"
                                list="ListEtab" ' . $hidden . ' >
			</li>
			<li class="list-group-item">
				<input type="text" class="form-control bg-light border-0 small" placeholder="Rechercher des utilisateurs..."
					aria-label="Search" aria-describedby="basic-addon2" name="searchUsers">
			</li>
			</ul>
				<div class="input-group-append">
					<button class="btn btn-primary" type="submit">
						<i class="fas fa-search fa-sm"></i>
					</button>
				</div>
			</div>
		</form>';
    return $content;
}

function form_search_group($config)
{
    $etab = $_POST['etab'] ?? $_GET['etab'] ?? $_POST['host'] ?? $_GET['host'] ?? $_SESSION['etab'] ?? "";
    if (! empty($etab)) {
        $value = "value = \"$etab\"";
    } else {
        $value = "";
    }
    /**
     * Si le host est passé en GET
     * inutile d'fficher l'input du host
     */
    $hidden = "type=\"text\"";
    if (! empty($_GET['host'])) {
        $hidden = "type =\"hidden\"";
    }

    $content = '<form class="d-none d-sm-inline-block form-inline mr-auto ml-md-2 my-2 my-md-2 mw-100 navbar-search" method="post" action="index.php?page=r">
			<div class="input-group">
			<ul class="list-group">
			<li  class="list-group-item">
				<input name ="SearchGroupBool"  type ="hidden" value="true">
				<input name ="etab"  class="form-control bg-light border-0
                                 small" placeholder="Limiter à l\'établissement..." ' . $value . ' aria-label="Search" aria-describedby="basic-addon2"
                                list="ListEtab" ' . $hidden . ' >
			</li>
			<li class="list-group-item">
				<input type="text" class="form-control bg-light border-0 small" placeholder="Rechercher un groupe..."
					 aria-label="SearchGrp" aria-describedby="basic-addon2" name="searchGroups">
			</li>
			</ul>
				<div class="input-group-append">
					<button class="btn btn-primary" type="submit">
						<i class="fas fa-search fa-sm"></i>
					</button>
				</div>
			</div>
		</form>';

    return $content;
}

function form_list_classes($config, $etab)
{
    $list_classes = list_classes_etab_fast(get_config($config, true, $etab)); // lsearch_ad($config, "*", "classe"); //filter_group_classes(get_config($config, true, $etab));
    $content = "";
    $content .= "<FORM  method=\"post\"  class=\"d-none d-sm-inline-block form-inline mr-auto ml-md-2 my-2 my-md-2 mw-100 navbar-search\" action=\"index.php?page=r\">\n";
    $content .= '<input name ="ListeClasse"  type ="hidden" value="true">';
    $content .= '<input name ="etab"  type ="hidden" value="' . $etab . '">';
    $content .= "<div class=\"input-group\">";
    $content .= "<SELECT NAME=\"classe\"  class=\"form-control bg-light border-0 small\" aria-label=\".form-select-lg\" onchange=submit()>";
    $content .= "<option value=\"\">Sélectionner</option>";
    foreach ($list_classes as $value_tmp) {
        $content .= "<option value=\"" . $value_tmp . "\"";
        $nom_etab = "";
        $content .= ">" . $value_tmp . "\n";
        $content .= "</option>";
    }
    $content .= "</SELECT></div></form>";
    return $content;
}

function form_list_parc($config, $etab, $action = "action_parc.php")
{
    $nb_etab = count(activated_etabs($config));
    $list_parcs = search_parcs(get_config($config, true, $etab), "*");
    $content = "";
    $content .= "<FORM  method=\"post\"  class=\"d-none d-sm-inline-block form-inline mr-auto ml-md-2 my-2 my-md-2 mw-100 navbar-search\" action=\"" . $action . "\">\n";
    $content .= "<div class=\"input-group\">";
    $content .= "<SELECT NAME=\"parc\"  class=\"form-control bg-light border-0 small\" aria-label=\".form-select-lg\" onchange=submit()>";
    $content .= "<option value=\"\">Choisir un parc à gérer</option>";
    foreach ($list_parcs as $value_tmp) {
        if (! empty($value_tmp["samaccountname"])) {
            $content .= "<option value=\"" . $value_tmp["samaccountname"] . "\"";
            $nom_etab = "";
            $content .= ">" . $value_tmp["name"] . " " . " de type " . $value_tmp["type"] . "\n";
            $content .= "</option>";
        }
    }
    $content .= "</SELECT></div></form>";
    return $content;
}

function annu_central($config, &$html)
{
    $html .= '<div class="row">';
    $titre = 'Recherche d\'utilisateurs dans l\'annuaire (4 lettres minimum)';
    $content = form_search_user($config);
    $html .= html_box(6, 6, 4, "success", $titre, $content, "fas fa-address-card fa-3x");
    $titre = 'Recherche d\'un groupe dans l\'annuaire';
    $content = form_search_group($config);
    $html .= html_box(6, 6, 4, "success", $titre, $content, "fas fa-users fa-3x");
    $html .= "</div>";

    $etab = $_POST['etab'] ?? $_GET['etab'] ?? $_POST['host'] ?? $_GET['host'] ?? "";
    /**
     * Résultat de la recherche
     */
    $searching = $_POST['searchUsers'] ?? "";
    $searchingGrp = $_POST['searchGroups'] ?? "";
    $SearchGroupBool = $_POST['SearchGroupBool'] ?? "";
    if ($SearchGroupBool) {
        if (empty($searchingGrp)) {
            $filter = "(cn=*)";
        } else {
            $filter = "(|(cn=Classe_$searchingGrp*)(cn=Cours_$searchingGrp*)(cn=Equipe_$searchingGrp*)(cn=Matiere_$searchingGrp*)(cn=*$searchingGrp*))";
            ;
        }
        $filter = preg_replace("/\*\*\*/", "*", $filter);
        $filter = preg_replace("/\*\*/", "*", $filter);
        /*
         */
        $result = filter_group($config, $filter);
        $content = "";
        $grps = [];
        $count = 0;
        if (! empty($result)) {
            foreach ($result as $key => $value) {
                if (preg_match("/(eleves|Profs|Administratifs|Documentaliste|Agent|Medical|Direction|Secretariat|VieScol|Autres)/i", $value['cn'])) {
                    $content .= "<li class=\"small\">" . "<a href=\"?page=r&dn=" . urlencode($value['dn']) . "&etab=" . $etab . "\" >" . $value['cn'] . "</a> " . "</li>";
                    $count += 1;
                } elseif ((($etab == "") || ($value['etab'] == $etab)) && (! preg_match('/(Classe_|Cours_|PP_)(.*)/', $value['cn']))) {
                    $grps['etab'] = $value['etab'];
                    $grps['cn'] = $value['cn'];
                    $grps['dn'] = $value['dn'];
                    $nom_groupe_a_afficher = preg_replace('/(Equipe_)(.*)/', '$2', $value['cn']);
                    $content .= "<li class=\"small\">" . "<a href=\"?page=r&dn=" . urlencode($grps['dn']) . "&etab=" . $grps['etab'] . "\" >" . $nom_groupe_a_afficher . "</a> " . etab_to_name(get_config($config, true, $grps['etab']), $grps['etab']) . "</li>";
                    $count += 1;
                }
            }
            $titre = "Il y a " . $count . " résultats pour la recherche pour \"<b>" . $searchingGrp . "</b>\"";
            $html .= html_box(12, 6, 4, "secondary", $titre, $content, "far fa-address-card fa-3x");
        } else {
            $titre = "Il n'y a aucun résultat pour la recherche pour \"<b>" . $searchingGrp . "</b>\"";
            $html .= html_box(12, 6, 4, "secondary", $titre, "", "far fa-address-card fa-3x");
        }
    }
    if ((! empty($searching)) && (strlen($searching) > 3)) {
        $result = search_ad(get_config($config, true, $etab), "(cn=*$searching*)", "filter", $config['dn']['people'], [
            'cn',
            'dn',
            'fullname',
            'pwdlastset'
        ]);
        $content = "   ";
        $users = [];
        if (! empty($result)) {
            foreach ($result as $key => $value) {
                if (($etab == "") || ($value['etab'] == $etab)) {
                    if ($value['pwdlastset'] != 0) {
                        $userActivated = "activé";
                    } else {
                        $userActivated = "non activé";
                    }
                    $users[$key] = search_user($config, $value["cn"]);
                    $userUai = $value["etab"];
                    $userCategorie = explode("=", explode(",", $value["dn"])[1])[1];
                    [
                        $Nom,
                        $Prenom
                    ] = explode(" ", $value["fullname"]);
                    $content .= "<li class=\"small\">" . "<a href=\"?page=r&cn=" . $value["cn"] . "\" >" . ucfirst(strtolower($Nom)) . " " . ucfirst(strtolower($Prenom)) . " (" . $value["cn"] . ", " . $userUai . ", " . $userCategorie . ", $userActivated)" . "</a></li>";
                }
            }
            $titre = "Il y a " . count($users) . " résultats pour la recherche pour \"<b>" . $searching . "</b>\"";
            $html .= html_box(12, 6, 4, "secondary", $titre, $content, "far fa-address-card fa-3x");
        } else {
            $titre = "Il n'y a aucun résultat pour la recherche pour \"<b>" . $searching . "</b>\"";
            $html .= html_box(12, 6, 4, "secondary", $titre, "", "far fa-address-card fa-3x");
        }
    }
    /**
     * Fiche utilisateur/Groupe/Classe après sélection
     */
    $content = "";
    if (! empty($_GET['cn'])) {
        $html .= "<!-- DEBUT -->";
        $titre = "Fiche de l'utilisateur " . $_GET['cn'];
        people_html($config, $content);
    } elseif (! empty($_GET['dn'])) {
        $html .= "<!-- DEBUT -->";
        $titre = "Groupe  : " . ldap_dn2cn($_GET['dn']);
        group_html(get_config($config, true, $etab), $content);
    } elseif (array_key_exists('ListeClasse', $_POST)) {
        $classe = $_POST['classe'];
        $titre = "Classe  : " . $classe . " de " . $etab;
        $result = search_ad(get_config($config, true, $etab), "$classe", 'classe', $config['dn']['groups']);
        $dn_classe = $result[0]['dn'];
        if (! empty($dn_classe)) {
            $_GET['dn'] = urlencode($dn_classe);
            group_html(get_config($config, true, $etab), $content);
        }
    }
    if (! empty($content)) {
        $html .= html_box_card(12, 7, 4, $titre, $content);
    }
}

function search_etab_form($etab_default, $page_retour, $hidden = "false")
{
    if ($hidden) {
        $hidden = "type=\"text\"";
    } else {
        $hidden = "type =\"hidden\"";
    }

    $return = '<form class="d-none d-sm-inline-block form-inline mr-auto ml-md-2 my-2 my-md-2 mw-100 navbar-search" method="post" action="index.php?page=' . $page_retour . '">
		<div class="input-group">
		<ul class="list-group">
		<li  class="list-group-item">
			<input name ="etab"
				class="form-control bg-light border-0 small"
				placeholder="Choisir l\'établissement..."
				aria-label="Search" aria-describedby="basic-addon2"
				value="' . $etab_default . '"
				list="ListEtab" autocomplete="off" ' . $hidden . '
				size="50"
			>
		</li>
		</ul>
			<div class="input-group-append">
				<button class="btn btn-primary" type="submit">
					<i class="fas fa-building"></i>
				</button>
			</div>
		</div>
	</form>';

    return $return;
}
?>