<?php

/*
 * Mise à jour du json des serveurs se4
 * En indiquant les derniers états
 *
 */
function update_servers_conf($force = false)
{
    $servers_conf = load_servers_conf(true);
    $success = false;
    /*
     * $force = true;
     */
    apcu_fetch('update_servers_conf', $success);
    if (($force) || (! $success)) {
        $config = get_config();
        $EtabNetworks = etab_networks($config);

        $allLastStats = allLastStats($config);
        foreach ($servers_conf as $cle => $valeur) {
            $uai = strtolower($valeur['fields']['uai']);
            $etat = $servers_conf[$cle]['fields']['etat'] ?? "";
            if ("$etat" != "inactif") {

                if ((isset($EtabNetworks["$uai"])) && (isset($EtabNetworks["$uai"]['pve_ip']))) {
                    $servers_conf[$cle]['fields']['pve_ip'] = $EtabNetworks[$uai]['pve_ip'];
                }

                /*
                 * Factoriser ces requêtes !
                 *
                 */
                if (isset($allLastStats[$uai])) {
                    if (array_key_exists("cpuload", $allLastStats[$uai])) {
                        $servers_conf[$cle]['fields']['cpu'] = $allLastStats[$uai]['cpuload'];
                    }
                    if (array_key_exists("ram", $allLastStats[$uai])) {
                        $servers_conf[$cle]['fields']['ram'] = $allLastStats[$uai]['ramused'];
                    }
                    if (isset($allLastStats[$uai]['se4ad_ip'])) {
                        $servers_conf[$cle]['fields']['se4ad_ip'] = long2ip($allLastStats[$uai]['se4ad_ip']);
                    }
                    if (isset($allLastStats[$uai]['se4fs_ip'])) {
                        $servers_conf[$cle]['fields']['se4fs_ip'] = long2ip($allLastStats[$uai]['se4fs_ip']);
                    }

                    if (isset($allLastStats[$uai]['alive'])) {
                        $servers_conf[$cle]['fields']['alive'] = $allLastStats[$uai]['alive'];
                        ;
                    }
                }
                if (array_key_exists("alive", $servers_conf[$cle]['fields'])) {
                    if ($servers_conf[$cle]['fields']['alive'] == 0) {
                        $servers_conf[$cle]['fields']['etat'] = "provisionning";
                    } elseif (time() - $servers_conf[$cle]['fields']['alive'] > 600) {
                        $servers_conf[$cle]['fields']['etat'] = "injoignable";
                    } elseif ($etat != "actif") {
                        $servers_conf[$cle]['fields']['etat'] = "actif";
                    }
                } else { // else le serveur était en provisionning et y reste en inactif
                    $servers_conf[$cle]['fields']['etat'] = "provisionning";
                }
            }
        }
        write_servers_conf($servers_conf);
        apcu_add('update_servers_conf', "OK", 500);
    }
}

function write_servers_conf($sc)
{
    $config = get_config();
    $file = $config['GeoJsonFile'];
    $texte = json_encode($sc, JSON_PRETTY_PRINT);
    file_put_contents($file, $texte);
}

function count_active_servers()
{
    $servers_conf = load_servers_conf();
    $total = 0;
    foreach ($servers_conf as $cle => $valeur) {
        if (($valeur['fields']['etat'] == "actif") or ($valeur['fields']['etat'] == "injoignable")) {
            $total += 1;
        }
    }
    return $total;
}

/*
 * Lecture du json des serveurs se4
 *
 */
function load_servers_conf($force = false)
{
    $config = get_config();
    $file = $config['GeoJsonFile'];
    $success = false;
    apcu_fetch('servers_conf', $success);
    if ((! $success) || ($force)) {
        $conf_json = file_get_contents($file);
        $conf = json_decode($conf_json, true);
        // conf en cache pour 500 s
        apcu_add('servers_conf', $conf, 500);
    } else {
        $conf = apcu_fetch('servers_conf');
    }
    return $conf;
}

function ServersConfArray()
{
    $servers_conf = load_servers_conf();
    $conf = [];
    foreach ($servers_conf as $cle => $valeur) {
        $uai = strtolower($valeur['fields']['uai']);
        $conf[$uai]['uai'] = $uai;
        $conf[$uai]['name'] = $valeur['fields']['titre'];
        $conf[$uai]['urlfs'] = $valeur['fields']['url1'];
        $conf[$uai]['etat'] = $valeur['fields']['etat'] ?? "";
        $conf[$uai]['pve_ip'] = $valeur['fields']['pve_ip'] ?? "";
        $conf[$uai]['coordinates'] = $valeur['geometry']['coordinates'] ?? "";
    }
    usort($conf, 'fonctionComparaison');
    return $conf;
}

function fonctionComparaison($a, $b)
{
    return $a['uai'] > $b['uai'];
}

function NomDepuisUAI($uai)
{
    $ServersConfArray = ServersConfArray();
    $name_id = array_search("$uai", array_column($ServersConfArray, 'uai'));
    return $ServersConfArray[$name_id]['name'];
}

function PVE_IP_DepuisUAI($uai)
{
    $ServersConfArray = ServersConfArray();
    $id = array_search("$uai", array_column($ServersConfArray, 'uai'));
    return $ServersConfArray[$id]['pve_ip'];
}

/*
 * Met un etat "provisionning"
 */
function server_provisionning($uai)
{
    $servers_conf = load_servers_conf(true);
    foreach ($servers_conf as $cle => $valeur) {
        if (($valeur['fields']['uai'] == "$uai") || ($valeur['fields']['uai'] == strtoupper("$uai"))) {
            $servers_conf[$cle]['fields']['etat'] = "provisionning";
            /*
             *
             * Activation de l'établissement (DNS...)
             *
             */
            $config = get_config();
            activate_etab($config, "$uai");
        }
    }
    write_servers_conf($servers_conf);
    apcu_delete('servers_conf');
}

function remove_provisionning($uai)
{
    $servers_conf = load_servers_conf(true);
    foreach ($servers_conf as $cle => $valeur) {
        if ($valeur['fields']['uai'] == strtoupper("$uai")) {
            $servers_conf[$cle]['fields']['etat'] = "inactif";
        }
    }
    write_servers_conf($servers_conf);
    apcu_delete('servers_conf');
}

?>