<?php

function sdpve($config, $ServersConfArray, &$html)
{
    $ServerChoice = "";
    foreach ($ServersConfArray as $cle => $valeur) {
        if ($valeur['etat'] == "actif") {
            $DefaultUAI = strtolower($valeur['uai']);
            $ServerChoice .= '<a class="dropdown-item" href="?page=sdpve&host=' . $valeur['uai'] . '">PVE ' . $valeur['uai'] . ' (' . $valeur['name'] . ')</a>';
        }
    }
    $host = $_GET['host'] ?? "";
    $name = NomDepuisUAI($host);
    if ($host == "") {
        $html .= '<div class="d-sm-flex align-items-center justify-content-between mb-4">';
        tabstats_pve($config, $ServersConfArray, $html);
        $html .= '</div>';
    } else {
        $html .= '<div class="d-sm-flex align-items-center justify-content-between mb-4">
                <h1 class="h4 mb-0 text-gray-800">Statistiques du PVE : ' . $host . ' (' . $name . ')</h1>';
        $html .= '<nav class="navbar navbar-expand navbar-light bg-light mb-4">
            
                        <ul class="navbar-nav ml-auto">
                            <li class="nav-item dropdown">
                                <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown"
                                    role="button" data-toggle="dropdown" aria-haspopup="true"
                                    aria-expanded="false">
                                    Choix du serveur
                                </a>
                                <div class="dropdown-menu dropdown-menu-right animated--grow-in"
                                    aria-labelledby="navbarDropdown">' . $ServerChoice . '</div>
                            </li>
                        </ul>
                    </nav>
                    </div>';

        // Ram et CPU
        $allStatsPVE = allLastStatsPVE($config);
        $html .= '<div class="row">';
        if (isset($allStatsPVE["pve-" . $host])) {
            $memtotal = $allStatsPVE["pve-" . $host]['memtotal'];
            $memused = $allStatsPVE["pve-" . $host]['memused'];
        } else {
            $memtotal = "";
            $memused = "";
        }
        if (($memtotal != 0) && ($memtotal != "")) {
            $ramPRC = round($memused / $memtotal * 100, 2);
        } else {
            $ramPRC = "---";
        }
        $content = "$ramPRC %";
        if ($ramPRC > 90) {
            $bg = "bg-danger";
        } elseif ($ramPRC > 50) {
            $bg = "bg-warning";
        } else {
            $bg = "bg-success";
        }
        $content .= '<div class="progress progress-sm mr-2">
             <div class="progress-bar ' . $bg . '" role="progressbar"
                style="width:' . $ramPRC . '%"
                aria-valuenow="' . $ramPRC . '"
                aria-valuemin="0"
                aria-valuemax="100"></div>
              </div>';
        $titre = "Mémoire utilisée";
        $html .= html_box(3, 6, 4, "success", $titre, $content, "fas  fa-tachometer-alt fa-2x");
        $titre = "Espace de stockage utilisé";

        if (isset($allStatsPVE["pve-" . $host])) {
            $diskTotal = $allStatsPVE["pve-" . $host]['blocks'];
            $diskUsed = $allStatsPVE["pve-" . $host]['used'];
        } else {
            $diskTotal = "";
            $diskUsed = "";
        }
        if (($diskTotal != 0) && ($diskTotal != "")) {
            $diskUsed = round($diskUsed / $diskTotal * 100, 2);
        } else {
            $diskUsed = "---";
        }
        $content = "$diskUsed %";
        if ($diskUsed > 90) {
            $bg = "bg-danger";
        } elseif ($diskUsed > 50) {
            $bg = "bg-warning";
        } else {
            $bg = "bg-success";
        }
        $content .= '<div class="progress progress-sm mr-2">
             <div class="progress-bar ' . $bg . '" role="progressbar"
                style="width:' . $diskUsed . '%"
                aria-valuenow="' . $diskUsed . '"
                aria-valuemin="0"
                aria-valuemax="100"></div>
              </div>';
        $html .= html_box(3, 6, 4, "success", $titre, $content, "fas  fa-microchip fa-2x");
        $titre = "Nombre de VM actives";
        $content = countPveNodesRunning($config, $host);
        $html .= html_box(3, 6, 4, "success", $titre, $content, "fas  fa-server fa-2x");
        $titre = "Accès rapides";
        $content = '<span class=""> <a href="' . $config['central_uri'] . "/" . $host . '/" alt="Interface du serveur SE4FS" target="_blank">SE4FS</a>';
        $content .= ' / <a href="https://' . $ServersConfArray[array_search($host, array_column($ServersConfArray, 'uai'))]['pve_ip'] . ':8006" alt="Interface du serveur proxmox" target="_blank">Proxmox</a>';
        $content .= ' / <a href="?page=sds&host=' . $host . '" alt="Statistiques du serveur SE4FS" >Stats. SE4</a></p>';
        $content .= '</span>';
        $html .= html_box(3, 6, 4, "success", $titre, $content, "fas fa-link fa-2x");
        $html .= "</div>";
        // Graphes de charge
        $html .= '<div class="row">
                        <div class="col-xl-6 col-lg-5">
                            <div class="card shadow mb-4">
                                <!-- Card Header - Dropdown -->
                                <div
                                    class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                                    <h6 class="m-0 font-weight-bold text-primary">CPU (nombre de processus)</h6>
                                </div>
                                <!-- Card Body -->
                                <div class="card-body">
                                <main id="ChargeServeurs1"></main>
                                </div>
                            </div>
                        </div>
                        <div class="col-xl-6 col-lg-5">
                            <div class="card shadow mb-4">
                                <!-- Card Header - Dropdown -->
                                <div
                                    class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                                    <h6 class="m-0 font-weight-bold text-primary">RAM utilisée en %</h6>
                                </div>
                                <!-- Card Body -->
                                <div class="card-body">
                                <main id="ChargeServeurs2"></main>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row">
						<div class="col-xl-12 col-lg-5">
							<div class="card shadow mb-4">
								<!-- Card Header - Dropdown -->
								<div
									class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
									<h6 class="m-0 font-weight-bold text-primary">Statistiques de l\'interface vmbr0 (en kb/s)</h6>
								</div>
								<!-- Card Body -->
								<div class="card-body">
								<main id="ChargeServeurs3"></main>
								</div>
							</div>
						</div>
				</div>';
    }
}
?>