<?php

// Stats des serveurs SE4
function sds($config, $ServersConfArray, &$html)
{
    $ServerChoice = "";

    foreach ($ServersConfArray as $cle => $valeur) {
        if (($valeur['etat'] != "inactif") && (($valeur['etat'] != "provisionning"))) {
            // $DefaultUAI = strtolower($valeur['uai']);
            $ServerChoice .= '<a class="dropdown-item" href="?page=sds&host=' . $valeur['uai'] . '">' . $valeur['uai'] . ' (' . $valeur['name'] . ')</a>';
        }
    }

    $host = $_GET['host'] ?? "";

    if ($host == "") {
        $html .= '<div class="d-sm-flex align-items-center justify-content-between mb-4">';
        tabstats($config, $ServersConfArray, $html);
        $html .= '</div>';
    } else {

        $name = NomDepuisUAI($host);

        $html = '<div class="d-sm-flex align-items-center justify-content-between mb-4">
            <h1 class="h4 mb-0 text-gray-800">Serveur SE4 : ' . $host . ' (' . $name . ')</h1>';
        $html .= '<nav class="navbar navbar-expand navbar-light bg-light mb-4">
            
                    <ul class="navbar-nav ml-auto">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown"
                                role="button" data-toggle="dropdown" aria-haspopup="true"
                                aria-expanded="false">
                                Choix du serveur
                            </a>
                            <div class="dropdown-menu dropdown-menu-right animated--grow-in"
                                aria-labelledby="navbarDropdown">' . $ServerChoice . '</div>
                        </li>
                    </ul>
                </nav>
                </div>';

        // NB Users/NB Machines
        $allLastStats = allLastStats($config);
        $AllLastVM = allLastStatsVM($config);

        $html .= '<div class="row">';
        $NBCOMPUTERS = $allLastStats[$host]['nbcomputers'];
        $NBUSERS = $allLastStats[$host]['nbUsers'];
        $content = $NBUSERS . " / " . $NBCOMPUTERS;
        $content .= "<ul class=\"list-group list-unstyled\">
        <li class=\"text-xs font-weight-lighter \">" . $allLastStats[$host]['nbUsersActivated'] . " activés.</li>
        <li class=\"text-xs font-weight-lighter\">Profs : " . $allLastStats[$host]['nbProfsActivated'] . " activés /" . $allLastStats[$host]['nbProfs'] . " </li>
        <li class=\"text-xs font-weight-lighter\">Élèves : " . $allLastStats[$host]['nbElevesActivated'] . " activés /" . $allLastStats[$host]['nbEleves'] . " </li>
        </ul>";
        $titre = "Utilisateurs / Machines";
        $html .= html_box(4, 6, 4, "success", $titre, $content, "fas  fa-tachometer-alt fa");
        $titre = "Connectés";
        $html .= html_box(4, 6, 4, "success", $titre, $allLastStats[$host]['nbusersconnected'], "fas  fa-user fa");

        $RAM_PRC = $allLastStats[$host]['ramused'];
        $CPUFS = $allLastStats[$host]['cpuload'];
        if (isset($AllLastVM['se4ad-' . $host])) {
            $CPUAD = round(100 * $AllLastVM['se4ad-' . $host]['cpu'], 2) ?? "";
        } else {
            $CPUAD = "..";
        }
        $titre = "RAM";
        $content = round($RAM_PRC, 2) . " %";
        // On ajoute une barre de progression
        $content .= '<div class="progress progress-sm mr-2">
                 <div class="progress-bar bg-info" role="progressbar"
                    style="width:' . $RAM_PRC . '%"
                    aria-valuenow="' . $RAM_PRC . '"
                    aria-valuemin="0"
                    aria-valuemax="100"></div>
                  </div>';
        $html .= html_box(4, 6, 4, "success", $titre, $content, "fas fa-memory");
        $titre = "CPU load (FS / AD)";
        $html .= html_box(4, 6, 4, "success", $titre, $CPUFS . " / " . $CPUAD, "fas fa-microchip");

        $titre = "Sauvegardes / Taille";
        [
            $NbSVG,
            $LastSVG,
            $sizeSVG
        ] = Sauvegardes($config, $host);
        if (("$NbSVG") && ("$LastSVG") && ($sizeSVG)) {
            $formatDate = "d M à H:i";
            $LastSVG = date($formatDate, $LastSVG);
            $sizeSVG = round($sizeSVG / (10 ** 12), 2);
        }
        $content = "<p title=\"" . $LastSVG . "\">$NbSVG / $sizeSVG</p>";
        $html .= html_box(4, 6, 4, "success", $titre, $content, "fas fa-server ");

        $titre = "Accès rapides";
        $content = '<span class=""> <a href="' . $config['central_uri'] . '/' . $host . '/admin/" alt="Interface du serveur SE4FS" target="_blank">SE4FS</a>';
        $content .= ' / <a href="https://' . $ServersConfArray[array_search($host, array_column($ServersConfArray, 'uai'))]['pve_ip'] . ':8006" alt="Interface du serveur proxmox" target="_blank">Proxmox</a>';
        $content .= ' / <a href="?page=sdpve&host=' . $host . '" alt="Statistiques du serveur PVE" >Stats. PVE</a></p>';
        $content .= '</span>';
        $html .= html_box(4, 6, 4, "success", $titre, $content, "fas fa-link");

        // $html .= "</div>";

        /*
         * Formulaires de recherche
         *
         */

        // $html .= '<div class="row">';
        $titre = 'Recherche d\'utilisateurs (4 lettres minimum)';
        $content = form_search_user($config);
        $html .= html_box(5, 6, 4, "success", $titre, $content, ""); // "fas fa-address-card");
        $titre = 'Classes';
        // $content = form_search_group($config);
        $content = form_list_classes($config, $host);
        $html .= html_box(3, 6, 4, "success", $titre, $content, "fas fa-users");
        $titre = 'Parcs';
        $content = "" . form_list_parc($config, $host);
        $html .= html_box(4, 6, 4, "success", $titre, $content, "fas fa-computer");
        $html .= "</div>";
        /*
         *
         *
         */
        // Graphes de charge
        $html .= '<div class="row">
                    <div class="col-xl-12 col-lg-5">
                        <div class="card shadow mb-4">
                            <!-- Card Header - Dropdown -->
                            <div
                                class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                                <h6 class="m-0 font-weight-bold text-primary"><div id="TbxUsersOnline">Utilisateurs connectés</div></h6>
                                <div class="dropdown no-arrow">
										<a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink"
											data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
											<i class="fas fa-calendar fa-sm fa-fw"></i>
										</a>
										<div class="dropdown-menu dropdown-menu-right shadow animated--fade-in"
											aria-labelledby="dropdownMenuLink">
											<div class="dropdown-header">Temporalité :</div>
											<a class="dropdown-item" href="#TbxUsersOnline" onclick="ShowStats(\'UsersOnline\',3,30);" >Mois</a>
											<a class="dropdown-item" href="#TbxUsersOnline" onclick="ShowStats(\'UsersOnline\',3,7);">Semaine</a>
											<a class="dropdown-item" href="#TbxUsersOnline" onclick="ShowStats(\'UsersOnline\',3,1);">Jour</a>
										</div>
								</div>
                            </div>
                            <!-- Card Body -->
                            <div class="card-body">
                            <main id="ChargeServeurs3"></main>
                            </div>
                        </div>
					</div>
                </div>
                <div class="row">
                    <div class="col-xl-6 col-lg-5">
                        <div class="card shadow mb-4">
                            <!-- Card Header - Dropdown -->
                            <div
                                class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                                <h6 class="m-0 font-weight-bold text-primary"><div id="TbxCPU">CPU (nombre de processus)</div></h6>
            
								<div class="dropdown no-arrow">
										<a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink"
											data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
											<i class="fas fa-calendar fa-sm fa-fw"></i>
										</a>
										<div class="dropdown-menu dropdown-menu-right shadow animated--fade-in"
											aria-labelledby="dropdownMenuLink">
											<div class="dropdown-header">Temporalité :</div>
											<a class="dropdown-item" href="#TbxCPU" onclick="ShowStats(\'CPU\',1,30);" >Mois</a>
											<a class="dropdown-item" href="#TbxCPU" onclick="ShowStats(\'CPU\',1,7);">Semaine</a>
											<a class="dropdown-item" href="#TbxCPU" onclick="ShowStats(\'CPU\',1,1);">Jour</a>
										</div>
								</div>
            
                            </div>
							<!-- Card Body -->
							<div class="card-body">
								<main id="ChargeServeurs1"></main>
							</div>
						</div>
                    </div>
            
                    <div class="col-xl-6 col-lg-5">
                        <div class="card shadow mb-4">
                            <!-- Card Header - Dropdown -->
                            <div
                                class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                                <h6 class="m-0 font-weight-bold text-primary"><div id="TbxRam">RAM utilisée en %</div></h6>
								<div class="dropdown no-arrow">
										<a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink"
											data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
											<i class="fas fa-calendar fa-sm fa-fw"></i>
										</a>
										<div class="dropdown-menu dropdown-menu-right shadow animated--fade-in"
											aria-labelledby="dropdownMenuLink">
											<div class="dropdown-header">Temporalité :</div>
											<a class="dropdown-item" href="#TbxRam" onclick="ShowStats(\'RAM\',2,30);" >Mois</a>
											<a class="dropdown-item" href="#TbxRam" onclick="ShowStats(\'RAM\',2,7);">Semaine</a>
											<a class="dropdown-item" href="#TbxRam" onclick="ShowStats(\'RAM\',2,1);">Jour</a>
										</div>
								</div>
							</div>
                            <!-- Card Body -->
                            <div class="card-body">
                            <main id="ChargeServeurs2"></main>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-xl-6 col-lg-5">
							<div class="card shadow mb-4">
								<!-- Card Header - Dropdown -->
								<div
									class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
									<h6 class="m-0 font-weight-bold text-primary"><div id="TbxUsersActiv">Utilisateurs activés</div></h6>
									<div class="dropdown no-arrow">
										<a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink"
											data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
											<i class="fas fa-calendar fa-sm fa-fw"></i>
										</a>
										<div class="dropdown-menu dropdown-menu-right shadow animated--fade-in"
											aria-labelledby="dropdownMenuLink">
											<div class="dropdown-header">Temporalité :</div>
											<a class="dropdown-item" href="#TbxUsersActiv" onclick="ShowStats(\'nbUsersActivated\',5,30);" >Mois</a>
											<a class="dropdown-item" href="#TbxUsersActiv" onclick="ShowStats(\'nbUsersActivated\',5,7);">Semaine</a>
											<a class="dropdown-item" href="#TbxUsersActiv" onclick="ShowStats(\'nbUsersActivated\',5,1);">Jour</a>
										</div>
									</div>
								</div>
								<!-- Card Body -->
								<div class="card-body">
								<main id="ChargeServeurs5"></main>
								</div>
							</div>
						</div>
                    <div class="col-xl-6 col-lg-5">
                        <div class="card shadow mb-4">
                            <!-- Card Header - Dropdown -->
                            <div
                                class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                                <h6 class="m-0 font-weight-bold text-primary"><div id="TbxDisks">Espace disque</div></h6>
                                <div class="dropdown no-arrow">
									<a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink"
										data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
										<i class="fas fa-calendar fa-sm fa-fw"></i>
									</a>
									<div class="dropdown-menu dropdown-menu-right shadow animated--fade-in"
										aria-labelledby="dropdownMenuLink">
										<div class="dropdown-header">Temporalité :</div>
										<a class="dropdown-item" href="#ChargeDisks" onclick="ShowStats(\'disks\',4,30);" >Mois</a>
										<a class="dropdown-item" href="#ChargeDisks" onclick="ShowStats(\'disks\',4,7);">Semaine</a>
										<a class="dropdown-item" href="#ChargeDisks" onclick="ShowStats(\'disks\',4,1);">Jour</a>
									</div>
								</div>
                            </div>
                            <!-- Card Body -->
                            <div class="card-body" id="ChargeDisks">
                            <main id="ChargeServeurs4"></main>
                            </div>
                        </div>
                    </div>
                </div>
                ';
    }
}
?>