<?php

/*
 * Liste les SE4 avec les soucis éventuels
 */
function tabstats($config, $ServersConfArray, &$html)
{
    $allLastStats = allLastStats($config);
    // $allStatsPVE = allLastStatsPVE($config);
    $AllStatsSauvegardes = AllStatsSauvegardes($config);
    $AllLastVM = allLastStatsVM($config);

    $tab = "";
    $tab = '<div class="col-xl-12 col-lg-7">
        <div class="card shadow mb-4">
                        <div class="card-header py-3">
                            <h6 class="m-0 font-weight-bold text-primary">Statistiques générales des SE4</h6>
                        </div>
                        <div class="card-body">
                            <div class="table-responsive">
                                <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0" >
                                    <thead>
                                        <tr class="text-xs">
                                            <th>UAI</th>
                                            <th>Disque (/home)</th>
                                            <th>Sauvegardes</th>
                                            <th>Dernier contact</th>
                                            <th>Utilisateurs</th>
                                            <th>CPU (FS)</th>
                                            <th>CPU (AD)</th>
                                        </tr>
                                    </thead>
                                    <tfoot>
                                        <tr class="text-xs">
                                            <th>UAI</th>
                                            <th>Disque (/home)</th>
                                            <th>Sauvegardes</th>
                                            <th>Dernier contact</th>
                                            <th>Utilisateurs</th>
                                            <th>CPU (FS)</th>
                                            <th>CPU (AD)</th>
                                        </tr>
                                    </tfoot>
                                    <tbody>
        
';
    foreach ($ServersConfArray as $cle => $valeur) {

        if (($valeur['etat'] == "actif") || ($valeur['etat'] == "injoignable")) {
            $uai = strtolower($valeur['uai']);
            if ($uai == "0000000x") {
                continue;
            }
            /*
             * Sauvegardes
             *
             */
            [
                $NbSVG,
                $LastSVG,
                $sizeSVG
            ] = $AllStatsSauvegardes["$uai"] ?? [
                "",
                "",
                ""
            ];
            $AlerteSVG = "";
            if (("$NbSVG") && ("$LastSVG") && ($sizeSVG)) {
                $formatDate = "d M à H:i";
                if (time() - $LastSVG > 3600 * 48) {
                    $DateSVG = (time() - $LastSVG) / 3600;
                    // ALERTE vieille sauvegarde
                    $AlerteSVG = "La sauvegarde date de plus de  " . round($DateSVG, 0) . " heures";
                }
                $LastSVG = date($formatDate, $LastSVG);
                $sizeSVG = round($sizeSVG / (10 ** 12), 2);
            }
            /*
             *
             * diskHomePRC
             */
            $diskHomePRC = $allLastStats[$uai]['home'];
            $ProgressBarDiskHome = "";
            if ($diskHomePRC > 90) {
                $bg = "bg-danger";
            } elseif ($diskHomePRC > 50) {
                $bg = "bg-warning";
            } else {
                $bg = "bg-success";
            }
            $ProgressBarDiskHome = '<div class="progress progress-sm mr-2">
         <div class="progress-bar ' . $bg . '" role="progressbar"
            style="width:' . $diskHomePRC . '%"
            aria-valuenow="' . $diskHomePRC . '"
            aria-valuemin="0"
            aria-valuemax="100"></div>
          </div>';

            /*
             *
             * cpu load du SE4FS (via metrics.conf)
             * et de l'AD via le PVE
             */
            $ProgressBarCpu = "";
            $cpuLoadFS = $allLastStats[$uai]['cpuload'] ?? ""; // cpuload du FS
            if ($cpuLoadFS > 50) {
                $bgFS = "bg-danger";
            } elseif ($cpuLoadFS > 5) {
                $bgFS = "bg-warning";
            } else {
                $bgFS = "bg-success";
            }
            $ProgressBarCpuFS = '<div class="progress progress-sm mr-2">
         <div class="progress-bar ' . $bgFS . '" role="progressbar"
            style="width:' . $cpuLoadFS . '%"
            aria-valuenow="' . $cpuLoadFS . '"
            aria-valuemin="0"
            aria-valuemax="100"></div>
          </div>';
            if (isset($AllLastVM['se4ad-' . $uai])) {
                $cpuLoadAD = round(100 * $AllLastVM['se4ad-' . $uai]['cpu'], 2) ?? ""; // cpuload du AD

                if ($cpuLoadAD > 50) {
                    $bgAD = "bg-danger";
                } elseif ($cpuLoadAD > 5) {
                    $bgAD = "bg-warning";
                } else {
                    $bgAD = "bg-success";
                }
                $ProgressBarCpuAD = '<div class="progress progress-sm mr-2">
             <div class="progress-bar ' . $bgAD . '" role="progressbar"
                style="width:' . $cpuLoadAD . '%"
                aria-valuenow="' . $cpuLoadAD . '"
                aria-valuemin="0"
                aria-valuemax="100"></div>
              </div>';
            } else {
                $ProgressBarCpuAD = "";
                $ProgressBarCpuFS = "";
                $cpuLoadAD = "--";
            }
            /*
             * Dernier contact
             */
            $alive = time() - $allLastStats[$uai]['alive'];
            if ($alive > 600) {
                $btnalive = "danger";
            } else if ($alive > 300) {
                $btnalive = "warning";
            } else if ($alive > 0) {
                $btnalive = "success";
            }

            $htmlSVG = "<a href=\"?page=eds&host=$uai\">";
            if (($NbSVG != "") && ($AlerteSVG == "")) {
                $htmlSVG .= "<center title=\"$LastSVG\">$NbSVG</center>";
            } elseif ($NbSVG == "") {
                $htmlSVG .= "<center title=\"Aucune sauvegarde\"><span class=\"btn-circle btn-sm btn-danger\">0<i class=\"fas fa-exclamation-triangle\"></i></span></center>";
            } else {
                $htmlSVG .= "<center title=\"$AlerteSVG ($LastSVG) \"><span class=\"btn-circle btn-sm btn-danger\">$NbSVG<i class=\"fas fa-exclamation-triangle\"></i></span></center>";
            }
            $htmlSVG .= "</a>";

            $tab .= "<tr><th>
        <a href=\"?page=sds&host=$uai\">
        $uai
        </a>
        <p class=\"text-xs\">" . $valeur['name'] . "</p>
        </th>
        <th>
        $diskHomePRC %
        $ProgressBarDiskHome
        </th>
        <th>
        $htmlSVG
        </th>
        <th>
        <span  class=\"btn btn-$btnalive btn-icon-split btn-sm text-xs\">
        " . $alive . " s </span>
        </th>
        <th>
        <ul class=\"list-group list-unstyled\">
        <li class=\"text-xs font-weight-lighter\">" . $allLastStats[$uai]['nbusersconnected'] . " connectés</li>
        <li class=\"text-xs font-weight-lighter \">" . $allLastStats[$uai]['nbUsersActivated'] . " activés /" . $allLastStats[$uai]['nbUsers'] . " </li>
        <li class=\"text-xs font-weight-lighter\">Profs : " . $allLastStats[$uai]['nbProfsActivated'] . " activés /" . $allLastStats[$uai]['nbProfs'] . " </li>
        <li class=\"text-xs font-weight-lighter\">Élèves : " . $allLastStats[$uai]['nbElevesActivated'] . " activés /" . $allLastStats[$uai]['nbEleves'] . " </li>
        </ul>
        </th>
        <th>
        $cpuLoadFS%
        $ProgressBarCpuFS
        </th>
        <th>
        $cpuLoadAD%
        $ProgressBarCpuAD
        </th>
        </tr>";
        }
    }

    $tab .= '</tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                    </div>
';

    $html .= $tab;
}

/*
 * Liste les SE4 avec les soucis éventuels
 */
function tabstats_pve($config, $ServersConfArray, &$html)
{
    $allLastStats = allLastStats($config);
    $allStatsPVE = allLastStatsPVE($config);
    // $AllStatsSauvegardes = AllStatsSauvegardes($config);
    // $AllLastVM = allLastStatsVM($config);
    // print_r($allStatsPVE);
    $tab = "";
    $tab = '<div class="col-xl-12 col-lg-7">
        <div class="card shadow mb-4">
                        <div class="card-header py-3">
                            <h6 class="m-0 font-weight-bold text-primary">Statistiques générales des serveurs Proxmox</h6>
                        </div>
                        <div class="card-body">
                            <div class="table-responsive">
                                <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0" >
                                    <thead>
                                        <tr class="text-xs">
                                            <th>PVE</th>
                                            <th>Disque</th>
                                            <th>RAM</th>
                                            <th>CPU</th>
                                            <th>Dernier contact</th>
                                        </tr>
                                    </thead>
                                    <tfoot>
                                        <tr class="text-xs">
                                            <th>PVE</th>
                                            <th>Disque</th>
                                            <th>RAM</th>
                                            <th>CPU</th>
                                            <th>Dernier contact</th>
                                        </tr>
                                    </tfoot>
                                    <tbody>
        
';
    foreach ($ServersConfArray as $cle => $valeur) {

        if (($valeur['etat'] == "actif") || ($valeur['etat'] == "injoignable")) {
            $uai = strtolower($valeur['uai']);
            if ($uai == "0000000x") {
                continue;
            }
            /*
             * Disques PVE
             */
            if (isset($allStatsPVE["pve-" . $uai])) {
                $diskTotal = $allStatsPVE["pve-" . $uai]['blocks'];
                $diskUsed = $allStatsPVE["pve-" . $uai]['used'];
            } else {
                $diskTotal = "";
                $diskUsed = "";
            }
            if (($diskTotal != 0) && ($diskTotal != "")) {
                $diskPRC = round($diskUsed / $diskTotal * 100, 2);
                if ($diskPRC > 90) {
                    $bg = "bg-danger";
                } elseif ($diskPRC > 50) {
                    $bg = "bg-warning";
                } else {
                    $bg = "bg-success";
                }
                $ProgressBarDisk = '<div class="progress progress-sm mr-2">
             <div class="progress-bar ' . $bg . '" role="progressbar"
                style="width:' . $diskPRC . '%"
                aria-valuenow="' . $diskPRC . '"
                aria-valuemin="0"
                aria-valuemax="100"></div>
              </div>';
            } else {
                $diskPRC = "---";
                $ProgressBarDisk = "";
            }
            /*
             *
             * Mémoire PVE
             *
             */
            if (isset($allStatsPVE["pve-" . $uai])) {
                $memtotal = $allStatsPVE["pve-" . $uai]['memtotal'];
                $memused = $allStatsPVE["pve-" . $uai]['memused'];
            } else {
                $memtotal = "";
                $memused = "";
            }
            if (($memtotal != 0) && ($memtotal != "")) {
                $ramPRC = round($memused / $memtotal * 100, 2);

                if ($ramPRC > 90) {
                    $bg = "bg-danger";
                } elseif ($ramPRC > 50) {
                    $bg = "bg-warning";
                } else {
                    $bg = "bg-success";
                }
                $ProgressBarRam = '<div class="progress progress-sm mr-2">
             <div class="progress-bar ' . $bg . '" role="progressbar"
                style="width:' . $ramPRC . '%"
                aria-valuenow="' . $ramPRC . '"
                aria-valuemin="0"
                aria-valuemax="100"></div>
              </div>';
            } else {
                $ramPRC = "---";
                $ProgressBarRam = "";
            }

            /*
             *
             * cpu load du PVE
             */
            $ProgressBarCpu = "";
            $cpuLoadPVE = round(100 * $allStatsPVE["pve-" . $uai]['cpu'], 2) ?? 0;
            if ($cpuLoadPVE > 50) {
                $bgcpupve = "bg-danger";
            } elseif ($cpuLoadPVE > 5) {
                $bgcpupve = "bg-warning";
            } else {
                $bgcpupve = "bg-success";
            }
            $ProgressBarCpuPVE = '<div class="progress progress-sm mr-2">
         <div class="progress-bar ' . $bgcpupve . '" role="progressbar"
            style="width:' . $cpuLoadPVE . '%"
            aria-valuenow="' . $cpuLoadPVE . '"
            aria-valuemin="0"
            aria-valuemax="100"></div>
          </div>';
            /*
             * Dernier contact
             */
            $alive = time() - $allLastStats[$uai]['alive'];
            if ($alive > 600) {
                $btnalive = "danger";
            } else if ($alive > 300) {
                $btnalive = "warning";
            } else if ($alive > 0) {
                $btnalive = "success";
            }

            $tab .= "<tr><th>
        <a href=\"?page=sdpve&host=$uai\">
        $uai
        </a>
        <p class=\"text-xs\">" . $valeur['name'] . "</p>
        </th>
        <th>
        $diskPRC %
        $ProgressBarDisk
        </th>
        <th>
        $ramPRC %
        $ProgressBarRam
        </th>
        <th>
        $cpuLoadPVE%
        $ProgressBarCpuPVE
        </th>
        <th>
        <span  class=\"btn btn-$btnalive btn-icon-split btn-sm text-xs\">
        " . $alive . " s </span>
        </th>
		</tr>
";
        }
    }

    $tab .= '</tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                    </div>
';

    $html .= $tab;
}
?>