<?php

function tdb($config, &$html)
{
    /*
     * page
     * Tableau de bord
     */
    $allLastStats = allLastStats($config);
    /*
     * On compte le nombre d'utilisateur total et le nombre d'utilisateurs activés.
     *
     */
    $nbTotalUsers = 0;
    $nbTotalUsersActivated = 0;
    $nbTotalUsersConnected = 0;

    foreach ($allLastStats as $uai => $value) {
        if (array_key_exists("nbUsersActivated", $value)) {
            $nbTotalUsersActivated += $value['nbUsersActivated'];
        }
        if (array_key_exists("nbUsers", $value)) {
            $nbTotalUsers += $value['nbUsers'];
        }
        if (array_key_exists("nbusersconnected", $value)) {
            $nbTotalUsersConnected += $value['nbusersconnected'];
        }
    }

    /*
     *
     */

    $html .= '          <!-- Première ligne -->
                    <div class="row">';
    /*
     * ND serveurs gérés
     */
    $titre = "Nombre serveurs / utilisateurs connectés";
    $content = count_active_servers();
    $content .= " / ";
    $content .= $nbTotalUsersConnected;

    $html .= html_box(3, 6, 4, "primary", $titre, $content, "fas fa-calendar fa-2x");
    // NB Users/NB Machines
    $NBCOMPUTERS = $allLastStats["0000000x"]['nbcomputers']; // LastStat("computers");

    $UsersActivatedPRC = round($nbTotalUsersActivated / $nbTotalUsers * 100);
    $content = "$nbTotalUsers / " . $NBCOMPUTERS;
    $content .= "
<p class=\"text-xs font-weight-lighter\">$nbTotalUsersActivated utilisateurs activés ($UsersActivatedPRC%)</p>
";

    $content .= '<div class="progress progress-sm mr-2">
             <div class="progress-bar bg-info" role="progressbar"
                style="width:' . $UsersActivatedPRC . '%"
                aria-valuenow="' . $UsersActivatedPRC . '"
                aria-valuemin="0"
                aria-valuemax="100"></div>
              </div>';
    $titre = "Utilisateurs / Machines";
    $html .= html_box(3, 6, 4, "success", $titre, $content, "fas  fa-tachometer-alt fa-2x");
    // RAM Serveur central
    $RAM_PRC = round($allLastStats["0000000x"]['ramused'], 2);
    $CPU = $allLastStats["0000000x"]['cpuload'];
    $titre = "RAM";
    $content = "$RAM_PRC %";
    // On ajoute une barre de progression
    $content .= '<div class="progress progress-sm mr-2">
             <div class="progress-bar bg-info" role="progressbar"
                style="width:' . $RAM_PRC . '%"
                aria-valuenow="' . $RAM_PRC . '"
                aria-valuemin="0"
                aria-valuemax="100"></div>
              </div>';
    $html .= html_box(3, 6, 4, "success", $titre, $content, "fas fa-microchip fa-2x");

    // ALERTES
    $nb_alerte = array_sum(array_map("count", alertes($config)));
    if ($nb_alerte == 0) {
        $content = "Aucune alerte";
        $color = "success";
    } elseif ($nb_alerte == 1) {
        $content = "Une alerte";
        $color = "danger";
    } else {
        $content = $nb_alerte . " alertes";
        $color = "danger";
    }
    $html .= html_box(3, 6, 4, "$color", "ALERTES", $content, "fas fa-bug fa-2x");
    $html .= ' </div>
<!--  Seconde rangée -->
<div class="row">
    <!-- Carte des serveurs -->
    <div class="col-xl-12 col-lg-7 ">
        <div class=" card shadow mb-4">
            <!-- Card Header - Dropdown -->
            <div
                class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                <h6 class="m-0 font-weight-bold text-primary">Carte des serveurs - Connexion directe aux serveurs SE4</h6>
            </div>
            <!-- Card Body -->
            <div class="card-body ">
                <center>
                    <div id="map"></div>
                </center>
            </div>
        </div>
    </div>
</div>
<div class="row">
    <!-- Charge du serveur central -->
    <div class="col-xl-12 col-lg-7">
        <div class="card shadow mb-4">
            <!-- Card Header - Dropdown -->
            <div
                class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                <h6 class="m-0 font-weight-bold text-primary">
                    <div id="txtStatsTDB">Nombre d\'utilisateurs connectés (Cinq derniers jours)</div>
                </h6>

                <div class="dropdown no-arrow">
                    <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink"
                        data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <i class="fas fa-calendar cta"></i>
                    </a>
                    <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in"
                        aria-labelledby="dropdownMenuLink">
                        <div class="dropdown-header">Temporalité :</div>
                        <a class="dropdown-item" href="#ChargeServeurs1" onclick="ShowStats(\'UsersOnline\',1,30);" >Mois</a>
                        <a class="dropdown-item" href="#ChargeServeurs1" onclick="ShowStats(\'UsersOnline\',1,7);">Semaine</a>
                        <a class="dropdown-item" href="#ChargeServeurs1" onclick="ShowStats(\'UsersOnline\',1,1);">Jour</a>
					</div>
				</div>
            </div>
            <!-- Card Body -->
            <div class="card-body">

            <main id="ChargeServeurs1"></main>

            </div>
        </div>
    </div>
</div>';
}
?>